"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _construct2 = _interopRequireDefault(require("@babel/runtime/helpers/construct"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _reactCodemirror = _interopRequireDefault(require("@uiw/react-codemirror"));

var _copyToClipboard = _interopRequireDefault(require("@uiw/copy-to-clipboard"));

var _reactSplit = _interopRequireDefault(require("@uiw/react-split"));

var _CodePen = _interopRequireDefault(require("./CodePen"));

var _icon = _interopRequireDefault(require("./icon"));

var _transform = require("./transform");

var CodePreview = /*#__PURE__*/function (_React$PureComponent) {
  (0, _inherits2.default)(CodePreview, _React$PureComponent);

  var _super = (0, _createSuper2.default)(CodePreview);

  function CodePreview() {
    var _this;

    (0, _classCallCheck2.default)(this, CodePreview);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.demoDom = /*#__PURE__*/_react.default.createRef();
    _this.editor = /*#__PURE__*/_react.default.createRef();
    _this.language = '';
    _this.initHeight = 3;
    _this.playerId = "".concat(parseInt(String(Math.random() * 1e9), 10).toString(36));
    _this.state = {
      errorMessage: '',
      fullScreen: false,
      copied: false,
      showEdit: false,
      width: 1
    };
    return _this;
  }

  (0, _createClass2.default)(CodePreview, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var language = this.props.language;
      this.language = typeof language === 'string' ? language : language ? language.name || '' : '';

      if (!this.props.noPreview) {
        this.executeCode(this.props.code);
      }

      window.addEventListener("popstate", function (e) {
        document.body.style.overflow = 'inherit';
      }, false);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var language = nextProps.language;
      this.language = typeof language === 'string' ? language : language ? language.name || '' : '';

      if (nextProps.noPreview !== this.props.noPreview) {
        this.executeCode(this.props.code);
      }
    }
  }, {
    key: "executeCode",
    value: function () {
      var _executeCode = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(codeStr) {
        var args, argv, Elm, _key2, input, _yield$BabelTransform, code, message;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (/(jsx|js)/.test(this.language)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _context.prev = 2;
                args = ['context', 'React', 'ReactDOM', 'Component'];
                argv = [this, _react.default, _reactDom.default, _react.Component];
                Elm = this.props.dependencies;

                for (_key2 in Elm) {
                  args.push(_key2);
                  argv.push(Elm[_key2]);
                }

                codeStr = codeStr.replace('_mount_', "document.getElementById('".concat(this.playerId, "')"));
                input = "".concat(codeStr);
                _context.next = 11;
                return (0, _transform.BabelTransform)(input);

              case 11:
                _yield$BabelTransform = _context.sent;
                code = _yield$BabelTransform.code;
                args.push(code); // eslint-disable-next-line no-new-func

                (0, _construct2.default)(Function, args).apply(null, argv);
                this.setState({
                  errorMessage: ''
                });
                _context.next = 23;
                break;

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](2);
                message = '';

                if (_context.t0 && _context.t0.message) {
                  message = _context.t0.message;
                } else {
                  message = JSON.stringify(_context.t0);
                }

                this.setState({
                  errorMessage: message
                });

              case 23:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 18]]);
      }));

      function executeCode(_x) {
        return _executeCode.apply(this, arguments);
      }

      return executeCode;
    }()
    /**
     * onCopyCode
     */

  }, {
    key: "onCopyCode",
    value: function onCopyCode() {
      var _this2 = this;

      var code = this.props.code;
      (0, _copyToClipboard.default)(code || '', function (isCopy) {
        _this2.setState({
          copied: isCopy
        });
      });
      setTimeout(function () {
        _this2.setState({
          copied: false
        });
      }, 2000);
    }
    /**
     * onFullScreen
     */

  }, {
    key: "onFullScreen",
    value: function onFullScreen() {
      var _this3 = this;

      var fullScreen = this.state.fullScreen;
      this.setState({
        fullScreen: !fullScreen
      }, function () {
        document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';

        if (!fullScreen && _this3.demoDom.current) {
          _this3.demoDom.current.style.maxWidth = 'inherit';
        }
      });
    }
  }, {
    key: "initOldHeight",
    value: function initOldHeight() {
      var demo = this.demoDom.current;

      if (this.initHeight === 3 && demo) {
        this.initHeight = demo.clientHeight;
      }
    }
    /**
     * onSwitchSource
     */

  }, {
    key: "onSwitchSource",
    value: function onSwitchSource() {
      var _this4 = this;

      var width = this.state.width;
      this.initOldHeight();
      this.setState({
        width: width === 1 ? '50%' : 1,
        showEdit: true
      }, function () {
        if (_this4.editor && _this4.editor.current && _this4.editor.current.editor) {
          _this4.editor.current.editor.setSize('100%', width !== 1 ? _this4.initHeight : '100%');
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props = this.props,
          style = _this$props.style,
          prefixCls = _this$props.prefixCls,
          language = _this$props.language,
          className = _this$props.className,
          editProps = _this$props.editProps,
          codePenOption = _this$props.codePenOption,
          code = _this$props.code,
          dependencies = _this$props.dependencies,
          onlyEdit = _this$props.onlyEdit,
          bordered = _this$props.bordered,
          noCode = _this$props.noCode,
          noPreview = _this$props.noPreview,
          noScroll = _this$props.noScroll,
          bgWhite = _this$props.bgWhite,
          otherProps = (0, _objectWithoutProperties2.default)(_this$props, ["style", "prefixCls", "language", "className", "editProps", "codePenOption", "code", "dependencies", "onlyEdit", "bordered", "noCode", "noPreview", "noScroll", "bgWhite"]);
      var isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
      var visiable = this.state.width === 1 ? false : [isOneItem ? 1 : 2];
      return /*#__PURE__*/_react.default.createElement(_reactSplit.default, (0, _extends2.default)({
        visiable: visiable,
        className: [className, prefixCls, noScroll ? "".concat(prefixCls, "-noScroll") : null, isOneItem ? "".concat(prefixCls, "-OneItem") : null, bordered ? "".concat(prefixCls, "-bordered") : null, this.state.fullScreen ? "".concat(prefixCls, "-fullScreen") : null].filter(Boolean).join(' ').trim(),
        style: (0, _objectSpread2.default)({
          flex: 1
        }, style)
      }, otherProps), !noPreview && !onlyEdit && /*#__PURE__*/_react.default.createElement("div", {
        ref: this.demoDom,
        className: ["".concat(prefixCls, "-demo"), !bgWhite ? "".concat(prefixCls, "-demo-bgPlaid") : null, this.state.errorMessage ? "".concat(prefixCls, "-demo-error") : null].filter(Boolean).join(' ').trim(),
        style: (0, _objectSpread2.default)({
          flex: 1
        }, this.state.width === 1 ? {
          width: '100%'
        } : {})
      }, this.state.errorMessage && /*#__PURE__*/_react.default.createElement("pre", null, /*#__PURE__*/_react.default.createElement("code", null, this.state.errorMessage)), /*#__PURE__*/_react.default.createElement("div", {
        className: ["".concat(prefixCls, "-demo-source"), this.state.errorMessage ? 'error' : null].filter(Boolean).join(' ').trim(),
        id: this.playerId
      })), (!noCode || onlyEdit) && /*#__PURE__*/_react.default.createElement("div", {
        style: {
          overflow: 'hidden',
          width: onlyEdit ? '100%' : this.state.width
        }
      }, (this.state.showEdit || onlyEdit) && /*#__PURE__*/_react.default.createElement(_reactCodemirror.default, (0, _extends2.default)({
        value: (code || '').replace(/\n$/, ''),
        ref: this.editor,
        options: {
          theme: 'monokai',
          mode: language
        }
      }, editProps, {
        onChange: function onChange(editor) {
          _this5.executeCode(editor.getValue());
        }
      }))), !isOneItem && !(noCode && noPreview) && !onlyEdit && /*#__PURE__*/_react.default.createElement("div", {
        style: {
          flex: 1,
          width: 29
        },
        className: "".concat(prefixCls, "-bar")
      }, codePenOption && /*#__PURE__*/_react.default.createElement(_CodePen.default, {
        prefixCls: prefixCls,
        options: codePenOption
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefixCls, "-bar-btn"),
        onClick: this.onSwitchSource.bind(this)
      }, this.state.width === 1 ? '源码' : '隐藏编辑器'), /*#__PURE__*/_react.default.createElement("div", {
        className: ["".concat(prefixCls, "-bar-iconbtns"), this.state.copied ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
        onClick: this.onCopyCode.bind(this)
      }, _icon.default.copy), /*#__PURE__*/_react.default.createElement("div", {
        className: ["".concat(prefixCls, "-bar-iconbtns"), this.state.fullScreen ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
        onClick: this.onFullScreen.bind(this)
      }, _icon.default.full)));
    }
  }]);
  return CodePreview;
}(_react.default.PureComponent);

exports.default = CodePreview;
CodePreview.defaultProps = {
  prefixCls: 'w-code-preview',
  language: 'jsx',
  code: '',
  editProps: {},
  noCode: false,
  bgWhite: false,
  onlyEdit: false,
  noPreview: false,
  bordered: true
};
module.exports = exports.default; 
//# sourceMappingURL=index.js.map